/*===========================================================================
 *
 * File:	Dfarch3d.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Wednesday, June 20, 2001
 *
 * Defines the class CDFArch3dFile for handling the 3D object BSA file.
 *
 *=========================================================================*/
#ifndef __DFARCH3D_H
#define __DFARCH3D_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "uesp/dagger/bsa/dfbsa.h"
  #include "uesp/dagger/df3dobj.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CDFArch3dFile Definition
 *
 * Handles the loading 3D objects from Daggerfall's ARCH3D.BSA file.
 *
 *=========================================================================*/
class CDFArch3dFile : public CDFBsaFile {

  /*---------- Begin Private Class Members ----------------------*/
private:


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CDFArch3dFile();
  //virtual void Destroy (void);

	/* Create and load a 3D object */
  boolean LoadObject (CDF3dObject** ppObject, const size_t Index);


 };
/*===========================================================================
 *		End of Class CDFArch3dFile Definition
 *=========================================================================*/



#endif
/*===========================================================================
 *		End of File Dfarch3d.H
 *=========================================================================*/
