/*===========================================================================
 *
 * File:	Dfimgutl.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, June 26, 2001
 *
 * Defines utility routines related to Daggerfall IMG files.
 *
 *=========================================================================*/
#ifndef __DFIMGUTL_H
#define __DFIMGUTL_H


/*===========================================================================
 *
 * Begin Required Include Files
 *
 *=========================================================================*/
  #include "uesp/dagger/image/dfimg.h"
  #include "uesp/dagger/image/dfcif.h"
  #include "uesp/dagger/image/dftexture.h"

	/* Files required for BMP export */
  #if defined(_WIN32)
    #include "windows.h"
  #endif

/*===========================================================================
 *		End of Required Include Files
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Function Prototypes
 *
 *=========================================================================*/

 	/* Save an CIF file to multiple PCX files */
  bool ExportDFCIFtoPCX (const char* pFilename, const CDFCifFile& CIFFile);

	/* Save an IMG file to a PCX file */
  bool ExportDFIMGtoPCX (const char* pFilename, const CDFImgFile& IMGFile);

	/* Save a texture files to PCX files */
  bool ExportDFTexturetoPCX (const char* pFilename, const CDFTextureFile&  TextureFile);
  bool ExportDFTxtImgtoPCX  (const char* pFilename, const CDFTextureImage& ImageFile);

	/* Standard BMP export functions */
  bool ExportDFTxtImgtoBMP (const char* pFilename, const CDFTextureImage& ImageFile);


/*===========================================================================
 *		End of Function Prototypes
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Dfimgutl.H
 *=========================================================================*/
