/*===========================================================================
 *
 * File:	Dfinutil.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	January 18, 2003
 *
 * Description
 *
 *=========================================================================*/
#ifndef __DFINUTIL_H
#define __DFINUTIL_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "dfpacked.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

	/* Expected size of installation */
  #define DFINSTALL_TOTAL_FILES 1562
  #define DFINSTALL_TOTAL_BYTES 540393000

	/* Size of the error string */
  #define DFINSTALL_ERROR_SIZE 512

	/* User when copying files */
  #define DFINSTALL_COPYBUFFER_SIZE 10000

/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/

  typedef struct {
    long	FileSize;	/* Size of current file in bytes */
    long	FileBytes;	/* Number of bytes copied in current file */
    const char* pFilename;	/* The current file being copied */
    int		TotalFiles;	/* Total files to copy */
    int		NumFiles;	/* Number of files currently copied */
    long	TotalBytes;	/* Total bytes to copy */
    long	NumBytes;	/* Number of bytes currently copied */
   } dfinstallinfo_t;

	/* Installation callback function */
  typedef int (*PDFINSTALLCALLBACK) (dfinstallinfo_t& InstallInfo, void *pData);

/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Function Prototypes
 *
 *=========================================================================*/

	/* Attempt to install game from the CD */
  bool DFInstallCDGame (const char* pSourcePath, const char* pDestPath, 
			PDFINSTALLCALLBACK pCallback, void* pData);

/*===========================================================================
 *		End of Function Prototypes
 *=========================================================================*/



#endif
/*===========================================================================
 *		End of File Dfinutil.H
 *=========================================================================*/
