/*===========================================================================
 *
 * File:	NifAutoNormalParticlesData.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 * 25 October 2003
 *	- Fixed a missing extra array of floats in some records.
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifAutoNormalParticlesData.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifAutoNormalParticlesData.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifAutoNormalParticlesData Constructor
 *
 *=========================================================================*/
CNifAutoNormalParticlesData::CNifAutoNormalParticlesData () {
  //DEFINE_FUNCTION("CNifAutoNormalParticlesData::CNifAutoNormalParticlesData()");
  m_pValues1   = NULL;
  m_pValues1a  = NULL;
  m_pValues3   = NULL;
  m_pValues4   = NULL;
  m_NumValues1 = 0;
 }
/*===========================================================================
 *		End of Class CNifAutoNormalParticlesData Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifAutoNormalParticlesData Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifAutoNormalParticlesData::Destroy (void) {
  //DEFINE_FUNCTION("CNifAutoNormalParticlesData::Destroy()");
  DestroyArrayPointer(m_pValues1);
  DestroyArrayPointer(m_pValues1a);
  DestroyArrayPointer(m_pValues3);
  DestroyArrayPointer(m_pValues4);
  m_NumValues1 = 0;

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifAutoNormalParticlesData::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifAutoNormalParticlesData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifAutoNormalParticlesData::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifAutoNormalParticlesData::Read()");
  bool Result;

  Destroy();

  Result = FileHandle.ReadShort(m_NumValues1);
  if (Result) Result = FileHandle.ReadFloat(m_Unknown1);
  if (!Result) return (false);

  if (m_NumValues1 < 0) {
    ErrorHandler.AddError(ERR_CUSTOM, "Invalid values1 array size %d (0x%08lX)!", (int) m_NumValues1, FileHandle.Tell()-6);
    return (false);
   }

  if (m_NumValues1 > 0) {				/* 3 */
    CreateArrayPointer(m_pValues1, float, m_NumValues1*NIF_ANPD_NUMFLOATS1);
    Result = FileHandle.Read((char *) m_pValues1, sizeof(float)*m_NumValues1*NIF_ANPD_NUMFLOATS1);
    if (!Result) return (false);
   }

  //SystemLog.Printf("\t\t\tANPData, After Values1 = 0x%08lX", FileHandle.Tell());
  Result = FileHandle.ReadLong(m_Unknown2);

  if (m_Unknown2 != 0) {				/* 4 */
    CreateArrayPointer(m_pValues1a, float, m_NumValues1*NIF_ANPD_NUMFLOATS1);
    Result = FileHandle.Read((char *)m_pValues1a, sizeof(float)*m_NumValues1*NIF_ANPD_NUMFLOATS1);
    if (!Result) return (false);
   }

  //SystemLog.Printf("\t\t\tANPData, After Values1a = 0x%08lX", FileHandle.Tell());
  if (Result) Result = FileHandle.Read((char *) &m_Values2, sizeof(nifpos4_t));
  if (Result) Result = FileHandle.ReadShort(m_Unknown3);
  if (Result) Result = FileHandle.ReadShort(m_Unknown4);
  if (!Result) return (false);
  //SystemLog.Printf("\t\t\tANPData, Before Values3 = 0x%08lX", FileHandle.Tell());

  if (m_Unknown4 != 0) {				/* 4 */
    CreateArrayPointer(m_pValues3, float, m_NumValues1*NIF_ANPD_NUMFLOATS3);
    Result = FileHandle.Read((char *)m_pValues3, sizeof(float)*m_NumValues1*NIF_ANPD_NUMFLOATS3);
    if (!Result) return (false);
   }

  //SystemLog.Printf("\t\t\tANPData, After Values3 = 0x%08lX", FileHandle.Tell());
  Result = FileHandle.ReadLong(m_Unknown5);
  if (Result) Result = FileHandle.ReadShort(m_Unknown6);
  if (Result) Result = FileHandle.ReadShort(m_Unknown7);
  if (Result) Result = FileHandle.ReadFloat(m_Unknown8);
  if (Result) Result = FileHandle.ReadShort(m_Unknown9);
  if (Result) Result = FileHandle.ReadShort(m_Unknown10);
  if (Result) Result = FileHandle.ReadShort(m_Unknown11);
  if (!Result) return (false);
  //SystemLog.Printf("\t\t\tANPData, Before Values4 = 0x%08lX", FileHandle.Tell());

  if (m_Unknown11 != 0) {				/* 1 */
    CreateArrayPointer(m_pValues4, float, m_NumValues1*NIF_ANPD_NUMFLOATS4);
    Result = FileHandle.Read((char *) m_pValues4, sizeof(float)*m_NumValues1*NIF_ANPD_NUMFLOATS4);
    if (!Result) return (false);
   }

  //SystemLog.Printf("\t\t\tANPData, After Values4 = 0x%08lX", FileHandle.Tell());
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifAutoNormalParticlesData::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifAutoNormalParticlesData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifAutoNormalParticlesData::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifAutoNormalParticlesData::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteShort(m_NumValues1);
  if (Result) Result = FileHandle.WriteFloat(m_Unknown1);
  if (!Result) return (false);

  if (m_NumValues1 > 0) {
    Result = FileHandle.Write((char *) m_pValues1, sizeof(float)*m_NumValues1*NIF_ANPD_NUMFLOATS1);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_Unknown2);

  if (m_Unknown2 != 0) {				
    Result = FileHandle.Write((char *)m_pValues1a, sizeof(float)*m_NumValues1*NIF_ANPD_NUMFLOATS1);
    if (!Result) return (false);
   }

  if (Result) Result = FileHandle.Write((char *) &m_Values2, sizeof(nifpos4_t));
  if (Result) Result = FileHandle.WriteShort(m_Unknown3);
  if (Result) Result = FileHandle.WriteShort(m_Unknown4);
  if (!Result) return (false);

  if (m_Unknown4 != 0) {
    Result = FileHandle.Write((char *)m_pValues3, sizeof(float)*m_NumValues1*NIF_ANPD_NUMFLOATS3);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_Unknown5);
  if (Result) Result = FileHandle.WriteShort(m_Unknown6);
  if (Result) Result = FileHandle.WriteShort(m_Unknown7);
  if (Result) Result = FileHandle.WriteFloat(m_Unknown8);
  if (Result) Result = FileHandle.WriteShort(m_Unknown9);
  if (Result) Result = FileHandle.WriteShort(m_Unknown10);
  if (Result) Result = FileHandle.WriteShort(m_Unknown11);
  if (!Result) return (false);

  if (m_Unknown11 != 0) {
    Result = FileHandle.Write((char *) m_pValues4, sizeof(float)*m_NumValues1*NIF_ANPD_NUMFLOATS4);
    if (!Result) return (false);
   }

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifAutoNormalParticlesData::Write()
 *=========================================================================*/