/*===========================================================================
 *
 * File:	NifBSAnimationNode.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFBSANIMATIONNODE_H
#define __NIFBSANIMATIONNODE_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
  #include "NifLongArray.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

  #define NIF_BSAN_NUMCOORS 16
  #define NIF_BSAN_NUMVALUES 4

/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifBSAnimationNode Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifBSAnimationNode : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  CString	m_NodeName;		/* Name string */

  long		m_Unknown1;		/* Unknown values */
  long		m_Unknown2;
  short		m_Unknown3;

  float		m_Coordinates[NIF_BSAN_NUMCOORS];

  CNifLongArray m_Array1;
  CNifLongArray m_Array2;
  CNifLongArray m_Array3;
  CNifLongArray m_Array4;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifBSAnimationNode();
  virtual ~CNifBSAnimationNode() { Destroy(); }
  virtual void Destroy (void);

  	/* Return the optional record name */
  virtual const char*  GetRecordName  (void) const { return (m_NodeName); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);


 };
/*===========================================================================
 *		End of Class CNifBSAnimationNode Definition
 *=========================================================================*/



#endif
/*===========================================================================
 *		End of File Niftrishape.H
 *=========================================================================*/
