/*===========================================================================
 *
 * File:	NifCamera.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifCamera.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifCamera.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifCamera Constructor
 *
 *=========================================================================*/
CNifCamera::CNifCamera () {
  //DEFINE_FUNCTION("CNifCamera::CNifCamera()");

 }
/*===========================================================================
 *		End of Class CNifCamera Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifCamera Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifCamera::Destroy (void) {
  DEFINE_FUNCTION("CNifCamera::Destroy()");
  
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifCamera::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifCamera Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifCamera::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifCamera::Read()");
  bool Result;

  Destroy();

  Result = NifReadString(FileHandle, m_CameraName);
  if (Result) Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadShort(m_Unknown3);
  if (Result) Result = FileHandle.Read((char *)&m_Floats[0], sizeof(float)*NIF_CAMERA_NUMFLOATS);
  if (Result) Result = FileHandle.ReadLong(m_Unknown4);
  if (Result) Result = FileHandle.ReadLong(m_Unknown5);
  if (!Result) return (false);

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifCamera::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifCamera Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifCamera::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifCamera::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = NifWriteString(FileHandle, m_CameraName);
  if (Result) Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteShort(m_Unknown3);
  if (Result) Result = FileHandle.Write((char *)&m_Floats[0], sizeof(float)*NIF_CAMERA_NUMFLOATS);
  if (Result) Result = FileHandle.WriteLong(m_Unknown4);
  if (Result) Result = FileHandle.WriteLong(m_Unknown5);
  if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifCamera::Write()
 *=========================================================================*/