/*===========================================================================
 *
 * File:	Nifendfile.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "nifendfile.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifEndFile.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifEndFile Constructor
 *
 *=========================================================================*/
CNifEndFile::CNifEndFile () {
  //DEFINE_FUNCTION("CNifEndFile::CNifEndFile()");
  m_Unknown1 = 0;
  m_Unknown2 = 0;
 }
/*===========================================================================
 *		End of Class CNifEndFile Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifEndFile Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifEndFile::Destroy (void) {
  //DEFINE_FUNCTION("CNifEndFile::Destroy()");
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifEndFile::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifEndFile Method - bool Read (FileHandle);
 *
 * Input the node data from the current position in the given file.  Assumes
 * that the current position in the file is the byte after the last character
 * in the "NifNode" name record header.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifEndFile::Read (CGenFile& FileHandle) {
  bool Result;
  
	/* Delete the current record contents */ 
  Destroy();

  
	/* Input first three numbers */
  Result = FileHandle.ReadChar(m_Unknown1);
  if (Result) Result = FileHandle.ReadShort(m_Unknown2);
  if (!Result) return (false);

  if (m_NameLength == 2) {
    Result = FileHandle.ReadChar(m_Unknown3);
    if (Result) Result = FileHandle.ReadShort(m_Unknown4);
    if (!Result) return (false);
   }

	/* Return success */
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifEndFile::Read()
 *=========================================================================*/
  

/*===========================================================================
 *
 * Class CNifEndFile Method - bool Write (FileHandle);
 *
 * Input the node data to the current position in the given file.  Outputs the
 * record header and data.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifEndFile::Write (CGenFile& FileHandle) {
  bool Result;

	/* Call the base class method first */
  //Result = CNifBaseRecord::Write(FileHandle);
  //if (!Result) return (false);

	/* Output the special case end record name */
  if (m_NameLength == 2) {
    Result = FileHandle.WriteLong(2);
    if (Result) Result = FileHandle.WriteShort(0);
    if (!Result) return (false);
   }
  else {
    Result = FileHandle.WriteLong(1);
    if (Result) Result = FileHandle.WriteChar(0);
    if (!Result) return (false);
   }

	/* Output data */
  Result = FileHandle.WriteChar(m_Unknown1);
  if (Result) Result = FileHandle.WriteShort(m_Unknown2);
  if (!Result) return (false);

  if (m_NameLength == 2) {
    Result = FileHandle.WriteChar(m_Unknown3);
    if (Result) Result = FileHandle.WriteShort(m_Unknown4);
    if (!Result) return (false);
   }

	/* Return success */
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifEndFile::Write()
 *=========================================================================*/



 