/*===========================================================================
 *
 * File:	NifFloatArray.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFFLOATARRAY_H
#define __NIFFLOATARRAY_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
   #define NIFFLOAT_OPTION_FIXEDSIZE   1
   #define NIFFLOAT_OPTION_SIZEFLAGGED 2
   #define NIFFLOAT_OPTION_SHORTSIZE   4
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifFloatArray Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifFloatArray {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long   m_Size;
  float* m_pData;
  long   m_AllocatedSize;
  long   m_Options;
  long   m_FixedSize;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifFloatArray();
  virtual ~CNifFloatArray() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

  void SetOptions (const long Value) { m_Options   = Value; }
  void SetSize    (const long Value) { m_FixedSize = Value; }

 };
/*===========================================================================
 *		End of Class CNifFloatArray Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifFloatArray.H
 *=========================================================================*/
