/*===========================================================================
 *
 * File:	NifFloatData.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifFloatData.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifFloatData.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifFloatData Constructor
 *
 *=========================================================================*/
CNifFloatData::CNifFloatData () {
  //DEFINE_FUNCTION("CNifFloatData::CNifFloatData()");
  m_pData = NULL;
  m_NumRecords = 0;
 }
/*===========================================================================
 *		End of Class CNifFloatData Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifFloatData Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifFloatData::Destroy (void) {
  //DEFINE_FUNCTION("CNifFloatData::Destroy()");
  DestroyArrayPointer(m_pData);
  m_NumRecords = 0;

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifFloatData::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifFloatData Method - bool Read (FileHandle);
 *
 * Protected class method to input the record from the current position in
 * the file.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifFloatData::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifFloatData::Read()");
  bool Result;

  Destroy();

  Result = FileHandle.ReadLong(m_NumRecords);
  if (Result) Result = FileHandle.ReadLong(m_Unknown1);
  if (!Result) return (false);

  if (m_NumRecords > 0) {
    CreateArrayPointer(m_pData, nifpos4_t, m_NumRecords);
    Result = FileHandle.Read((char *)&m_pData[0], sizeof(nifpos4_t)*m_NumRecords);
    if (!Result) return (false);
   }

  SetIsLoaded(true);
  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifFloatData::Read()
 =========================================================================*/


/*===========================================================================
 *
 * Class CNifFloatData Method - bool Write (FileHandle);
 *
 * Protected class method to output the record from the current position in
 * the file.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifFloatData::Write (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifFloatData::Write()");
  bool Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_NumRecords);
  if (Result) Result = FileHandle.WriteLong(m_Unknown1);
  if (!Result) return (false);

  if (m_NumRecords > 0) {
    Result = FileHandle.Write((char *)&m_pData[0], sizeof(nifpos4_t)*m_NumRecords);
    if (!Result) return (false);
   }
  
  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifFloatData::Write()
 =========================================================================*/

