/*===========================================================================
 *
 * File:	NifGravity.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFGRAVITY_H
#define __NIFGRAVITY_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_GRAV_NUMFLOATS 8
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifGravity Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifGravity : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long	m_Unknown1;
  long	m_Unknown2;
  long  m_Unknown3;
  float m_Floats[NIF_GRAV_NUMFLOATS];


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifGravity();
  virtual ~CNifGravity() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifGravity Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifGravity.H
 *=========================================================================*/
