/*===========================================================================
 *
 * File:	NifMorphData.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFMORPHDATA_H
#define __NIFMORPHDATA_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
 
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifMorphDataRecord Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifMorphDataRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long		m_NumPoints4;
  long		m_Unknown1;
  float*	m_pFloats;
  long		m_NumPoints3;	/* Set by parent object */


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifMorphDataRecord();
  virtual ~CNifMorphDataRecord() { Destroy(); }
  virtual void Destroy (void);

  long GetNumFloats (void) const { return (m_NumPoints3*3 + m_NumPoints4*4); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);


  void SetNumPoints3 (const long Value) { m_NumPoints3 = Value; }


 };
/*===========================================================================
 *		End of Class CNifMorphDataRecord Definition
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifMorphData Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifMorphData : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long		m_NumRecords;
  long		m_NumPoints;
  char		m_Unknown1;

  CNifMorphDataRecord*	m_pRecords;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifMorphData();
  virtual ~CNifMorphData() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);


 };
/*===========================================================================
 *		End of Class CNifMorphData Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifKeyFrameData.H
 *=========================================================================*/
