/*===========================================================================
 *
 * File:	Nifparticlenode.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFPARTICLENODE_H
#define __NIFPARTICLENODE_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_PARTNODE_NUMVALUES 22
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifParticleNode Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifParticleNode : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  CString	m_ParticleName;

  long		m_Unknown1;
  long		m_Unknown2;
  short		m_Unknown3;

  float		m_Values[NIF_PARTNODE_NUMVALUES];



  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifParticleNode();
  virtual ~CNifParticleNode() { Destroy(); }
  virtual void Destroy (void);

  	/* Return the optional record name */
  virtual const char*  GetRecordName  (void) const { return (m_ParticleName); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);


 };
/*===========================================================================
 *		End of Class CNifParticleNode Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Nifparticlenode.H
 *=========================================================================*/
