/*===========================================================================
 *
 * File:	NifPathController.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifPathController.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifPathController.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPathController Constructor
 *
 *=========================================================================*/
CNifPathController::CNifPathController () {
  //DEFINE_FUNCTION("CNifPathController::CNifPathController()");
 
 }
/*===========================================================================
 *		End of Class CNifPathController Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPathController Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifPathController::Destroy (void) {
  //DEFINE_FUNCTION("CNifPathController::Destroy()");
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifPathController::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPathController Method - bool Read (FileHandle);
 *
 * Input the node data from the current position in the given file.  Assumes
 * that the current position in the file is the byte after the last character
 * in the "NifNode" name record header.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifPathController::Read (CGenFile& FileHandle) {
  bool Result;
  
	/* Delete the current record contents */ 
  Destroy();
  
  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadShort(m_Unknown2);
  if (Result) Result = FileHandle.Read((char *)&m_Position, sizeof(nifpos4_t));
  if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  if (Result) Result = FileHandle.ReadLong(m_Unknown4);
  if (Result) Result = FileHandle.ReadLong(m_Unknown5);
  if (Result) Result = FileHandle.ReadLong(m_Unknown6);
  if (Result) Result = FileHandle.ReadShort(m_Unknown7);
  if (Result) Result = FileHandle.ReadLong(m_Unknown8);
  if (Result) Result = FileHandle.ReadLong(m_Unknown9);
  if (!Result) return (false);

 	/* Return success */
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifPathController::Read()
 *=========================================================================*/
  

/*===========================================================================
 *
 * Class CNifPathController Method - bool Write (FileHandle);
 *
 * Input the node data to the current position in the given file.  Outputs the
 * record header and data.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifPathController::Write (CGenFile& FileHandle) {
  bool Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteShort(m_Unknown2);
  if (Result) Result = FileHandle.Write((char *)&m_Position, sizeof(nifpos4_t));
  if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  if (Result) Result = FileHandle.WriteLong(m_Unknown4);
  if (Result) Result = FileHandle.WriteLong(m_Unknown5);
  if (Result) Result = FileHandle.WriteLong(m_Unknown6);
  if (Result) Result = FileHandle.WriteShort(m_Unknown7);
  if (Result) Result = FileHandle.WriteLong(m_Unknown8);
  if (Result) Result = FileHandle.WriteLong(m_Unknown9);
  if (!Result) return (false);

	/* Return success */
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifPathController::Write()
 *=========================================================================*/



 