/*===========================================================================
 *
 * File:	NifPosData.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifPosData.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifPosData.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPosData Constructor
 *
 *=========================================================================*/
CNifPosData::CNifPosData () {
  //DEFINE_FUNCTION("CNifPosData::CNifPosData()");
  m_pData = NULL;
  m_NumRecords = 0;
 }
/*===========================================================================
 *		End of Class CNifPosData Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPosData Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifPosData::Destroy (void) {
  DEFINE_FUNCTION("CNifPosData::Destroy()");
  
  m_NumRecords = 0;
  DestroyArrayPointer(m_pData);

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifPosData::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPosData Method - int GetNumRecordFloats (void);
 *
 * Description
 *
 *=========================================================================*/
int CNifPosData::GetNumRecordFloats (void) {
  switch (m_Unknown1) {
    case 1: return (4);
    case 2: return (10);
    default: return (10);
   }
 }
/*===========================================================================
 *		End of Class Method CNifPosData::GetNumRecordFloats()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPosData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifPosData::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifPosData::Read()");
  bool Result;
  int  NumFloats;

  Destroy();

  Result = FileHandle.ReadLong(m_NumRecords);
  if (Result) Result = FileHandle.ReadLong(m_Unknown1);
  if (!Result) return (false);

  if (m_NumRecords > 0) {
    NumFloats = GetNumRecordFloats();
    CreateArrayPointer(m_pData, float, NumFloats*m_NumRecords);
    Result = FileHandle.Read((char *)&m_pData[0], sizeof(float)*NumFloats*m_NumRecords);
    if (!Result) return (false);
   }

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifPosData::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPosData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifPosData::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifPosData::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_NumRecords);
  if (Result) Result = FileHandle.WriteLong(m_Unknown1);
  if (!Result) return (false);

  if (m_NumRecords > 0) {
    Result = FileHandle.Write((char *)&m_pData[0], sizeof(float)*GetNumRecordFloats()*m_NumRecords);
    if (!Result) return (false);
   }

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifPosData::Write()
 *=========================================================================*/