/*===========================================================================
 *
 * File:	NifPosData.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFPOSDATA_H
#define __NIFPOSDATA_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_POSDATA_NUMFLOATS 10
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/



/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)


#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifPosData Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifPosData : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long		m_NumRecords;
  long		m_Unknown1;
  float*	m_pData;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifPosData();
  virtual ~CNifPosData() { Destroy(); }
  virtual void Destroy (void);

  int GetNumRecordFloats (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifPosData Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifVisData.H
 *=========================================================================*/
