/*===========================================================================
 *
 * File:	Nifrootcollisonnode.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFROOTCOLLISONNODE_H
#define __NIFROOTCOLLISONNODE_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
  #include "NifLongArray.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

  #define NIF_COLNODE_NUMVALUES 18

/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifRootCollisionNode Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifRootCollisionNode : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  CString	m_NodeString;	
  long		m_Unknown1;
  long		m_Unknown2;
  short		m_Unknown3;

  float		m_Values[NIF_COLNODE_NUMVALUES];

  CNifLongArray m_Values1;
  long		m_Unknown4;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifRootCollisionNode();
  virtual ~CNifRootCollisionNode() { Destroy(); }
  virtual void Destroy (void);

  	/* Return the optional record name */
  virtual const char* GetRecordName  (void) const { return (m_NodeString); }

	/* Get class members */
  float*	 GetFloatData  (void) { return (&m_Values[0]); }
  CNifLongArray* GetChildArray (void) { return (&m_Values1); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifRootCollisionNode Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Nifrootcollisonnode.H
 *=========================================================================*/
