/*===========================================================================
 *
 * File:	NifRotatingParticles.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFROTATINGPARTICLES_H
#define __NIFROTATINGPARTICLES_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
  #include "NifLongArray.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_ROTPART_NUMFLOATS  15
  #define NIF_ROTPART_NUMLONGS   7
  #define NIF_ROTPART_NUMLONGS1  3
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifRotatingParticles Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifRotatingParticles : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  CString	m_ParticleName;
  long		m_Unknown1;
  long		m_Unknown2;
  long		m_Unknown3;
  short		m_Unknown4;
  float		m_Floats[NIF_ROTPART_NUMFLOATS];
  long		m_Values[NIF_ROTPART_NUMLONGS];

  CNifLongArray m_LongArray;
  long		m_Values1[NIF_ROTPART_NUMLONGS1];


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifRotatingParticles();
  virtual ~CNifRotatingParticles() { Destroy(); }
  virtual void Destroy (void);

	/* Return the optional record name */
  virtual const char*  GetRecordName  (void) const { return (m_ParticleName); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifRotatingParticles Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifRotatingParticles.H
 *=========================================================================*/
