/*===========================================================================
 *
 * File:	NifRotatingParticlesData.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifRotatingParticlesData.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifRotatingParticlesData.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRotatingParticlesData Constructor
 *
 *=========================================================================*/
CNifRotatingParticlesData::CNifRotatingParticlesData () {
  //DEFINE_FUNCTION("CNifRotatingParticlesData::CNifRotatingParticlesData()");
  m_pValues1 = NULL;
  m_pValues3 = NULL;
  m_pValues4 = NULL;
  m_NumValues1 = 0;
 }
/*===========================================================================
 *		End of Class CNifRotatingParticlesData Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRotatingParticlesData Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifRotatingParticlesData::Destroy (void) {
  //DEFINE_FUNCTION("CNifRotatingParticlesData::Destroy()");

  DestroyArrayPointer(m_pValues1);
  DestroyArrayPointer(m_pValues3);
  DestroyArrayPointer(m_pValues4);
  m_NumValues1 = 0;

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifRotatingParticlesData::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRotatingParticlesData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifRotatingParticlesData::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifRotatingParticlesData::Read()");
  bool Result;

  Destroy();

  Result = FileHandle.ReadShort(m_NumValues1);
  if (Result) Result = FileHandle.ReadFloat(m_Unknown1);
  if (!Result) return (false);

  if (m_NumValues1 < 0) {
    ErrorHandler.AddError(ERR_CUSTOM, "Invalid values1 array size %d (0x%08lX)!", (int) m_NumValues1, FileHandle.Tell()-6);
    return (false);
   }

  if (m_NumValues1 > 0) {
    CreateArrayPointer(m_pValues1, float, m_NumValues1*NIF_RPD_NUMFLOATS1);
    Result = FileHandle.Read((char *) m_pValues1, sizeof(float)*m_NumValues1*NIF_RPD_NUMFLOATS1);
    if (!Result) return (false);
   }

  //SystemLog.Printf("\t\t\tRPData, After Values1 = 0x%08lX", FileHandle.Tell());
  Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.Read((char *) &m_Values2, sizeof(nifpos4_t));
  if (Result) Result = FileHandle.ReadShort(m_Unknown3);
  if (Result) Result = FileHandle.ReadShort(m_Unknown4);
  if (!Result) return (false);
  //SystemLog.Printf("\t\t\tRPData, Before Values3 = 0x%08lX", FileHandle.Tell());

  if (m_Unknown4 != 0) {
    CreateArrayPointer(m_pValues3, float, m_NumValues1*NIF_RPD_NUMFLOATS3);
    Result = FileHandle.Read((char *)m_pValues3, sizeof(float)*m_NumValues1*NIF_RPD_NUMFLOATS3);
    if (!Result) return (false);
   }

  //SystemLog.Printf("\t\t\tRPData, After Values3 = 0x%08lX", FileHandle.Tell());
  Result = FileHandle.ReadLong(m_Unknown5);
  if (Result) Result = FileHandle.ReadShort(m_Unknown6);
  if (Result) Result = FileHandle.ReadShort(m_Unknown7);
  if (Result) Result = FileHandle.ReadFloat(m_Unknown8);
  if (Result) Result = FileHandle.ReadShort(m_Unknown9);
  if (Result) Result = FileHandle.ReadShort(m_Unknown10);
  if (Result) Result = FileHandle.ReadShort(m_Unknown11);
  if (!Result) return (false);
  //SystemLog.Printf("\t\t\tRPData, Before Values4 = 0x%08lX", FileHandle.Tell());

  if (m_Unknown11 != 0) {
    CreateArrayPointer(m_pValues4, float, m_NumValues1*NIF_RPD_NUMFLOATS4);
    Result = FileHandle.Read((char *) m_pValues4, sizeof(float)*m_NumValues1*NIF_RPD_NUMFLOATS4);
    if (!Result) return (false);
   }

  //SystemLog.Printf("\t\t\tRPData, After Values4 = 0x%08lX", FileHandle.Tell());
  Result = FileHandle.ReadLong(m_Unknown12);
  if (!Result) return (false);
  
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifRotatingParticlesData::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRotatingParticlesData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifRotatingParticlesData::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifRotatingParticlesData::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteShort(m_NumValues1);
  if (Result) Result = FileHandle.WriteFloat(m_Unknown1);
  if (!Result) return (false);

  if (m_NumValues1 > 0) {
    Result = FileHandle.Write((char *) m_pValues1, sizeof(float)*m_NumValues1*NIF_RPD_NUMFLOATS1);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.Write((char *) &m_Values2, sizeof(nifpos4_t));
  if (Result) Result = FileHandle.WriteShort(m_Unknown3);
  if (Result) Result = FileHandle.WriteShort(m_Unknown4);
  if (!Result) return (false);

  if (m_Unknown4 != 0) {
    Result = FileHandle.Write((char *)m_pValues3, sizeof(float)*m_NumValues1*NIF_RPD_NUMFLOATS3);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_Unknown5);
  if (Result) Result = FileHandle.WriteShort(m_Unknown6);
  if (Result) Result = FileHandle.WriteShort(m_Unknown7);
  if (Result) Result = FileHandle.WriteFloat(m_Unknown8);
  if (Result) Result = FileHandle.WriteShort(m_Unknown9);
  if (Result) Result = FileHandle.WriteShort(m_Unknown10);
  if (Result) Result = FileHandle.WriteShort(m_Unknown11);
  if (!Result) return (false);

  if (m_Unknown11 != 0) {
    Result = FileHandle.Write((char *) m_pValues4, sizeof(float)*m_NumValues1*NIF_RPD_NUMFLOATS4);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_Unknown12);
  if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifRotatingParticlesData::Write()
 *=========================================================================*/