/*===========================================================================
 *
 * File:	NifSkinData.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFSKINDATA_H
#define __NIFSKINDATA_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_SKINDATARECORD_NUMFLOATS 17
  #define NIF_SKINDATA_NUMFLOATS 13
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)

  typedef struct {
    short  sValue;
    float  fValue;
   } nifskindatagroup_t;

#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifSkinDataRecord Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifSkinDataRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  float			m_Floats[NIF_SKINDATARECORD_NUMFLOATS];
  short			m_ArraySize;
  nifskindatagroup_t*	m_pArray;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifSkinDataRecord();
  virtual ~CNifSkinDataRecord() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);


 };
/*===========================================================================
 *		End of Class CNifSkinDataRecord Definition
 *=========================================================================*/



/*===========================================================================
 *
 * Begin Class CNifSkinData Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifSkinData : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  float		m_Floats[NIF_SKINDATA_NUMFLOATS];
  long		m_NumRecords;
  long		m_Unknown1;

  CNifSkinDataRecord*	m_pRecords;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifSkinData();
  virtual ~CNifSkinData() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifSkinData Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifSkinData.H
 *=========================================================================*/
