/*===========================================================================
 *
 * File:	Nifsourcetexture.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "nifsourcetexture.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifSourceTexture.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifSourceTexture Constructor
 *
 *=========================================================================*/
CNifSourceTexture::CNifSourceTexture () {
  //DEFINE_FUNCTION("CNifSourceTexture::CNifSourceTexture()");
 }
/*===========================================================================
 *		End of Class CNifSourceTexture Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifSourceTexture Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifSourceTexture::Destroy (void) {
  DEFINE_FUNCTION("CNifSourceTexture::Destroy()");

	/* Call the base class method */
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifSourceTexture::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifSourceTexture Method - bool Read (FileHandle);
 *
 * Input the node data from the current position in the given file.  Assumes
 * that the current position in the file is the byte after the last character
 * in the "NifNode" name record header.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifSourceTexture::Read (CGenFile& FileHandle) {
  bool Result;

	/* Delete the current record contents */
  Destroy();

  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  if (Result) Result = FileHandle.ReadChar(m_Unknown4);

  if (m_Unknown4 == 0x01) {
    if (Result) Result = NifReadString(FileHandle, m_TextureName);
   }
  else {
    if (Result) Result = FileHandle.ReadChar(m_Unknown4a);
    if (Result) Result = FileHandle.ReadLong(m_Unknown4b);
   }

  if (Result) Result = FileHandle.ReadLong(m_Unknown5);
  if (Result) Result = FileHandle.ReadLong(m_Unknown6);
  if (Result) Result = FileHandle.ReadLong(m_Unknown7);
  if (Result) Result = FileHandle.ReadChar(m_Unknown8);
  if (!Result) return (false);

	/* Return success */
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifSourceTexture::Read()
 *=========================================================================*/
  

/*===========================================================================
 *
 * Class CNifSourceTexture Method - bool Write (FileHandle);
 *
 * Input the node data to the current position in the given file.  Outputs the
 * record header and data.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifSourceTexture::Write (CGenFile& FileHandle) {
  bool Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  if (Result) Result = FileHandle.WriteChar(m_Unknown4);

  if (m_Unknown4 == 0x01) {
    if (Result) Result = NifWriteString(FileHandle, m_TextureName);
   }
  else {
    if (Result) Result = FileHandle.WriteChar(m_Unknown4a);
    if (Result) Result = FileHandle.WriteLong(m_Unknown4b);
   }

  if (Result) Result = FileHandle.WriteLong(m_Unknown5);
  if (Result) Result = FileHandle.WriteLong(m_Unknown6);
  if (Result) Result = FileHandle.WriteLong(m_Unknown7);
  if (Result) Result = FileHandle.WriteChar(m_Unknown8);
  if (!Result) return (false);

	/* Return success */
  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifSourceTexture::Write()
 *=========================================================================*/

