/*===========================================================================
 *
 * File:	Nifstringdata.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "nifstringdata.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifStringData.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifStringData Constructor
 *
 *=========================================================================*/
CNifStringData::CNifStringData () {
  //DEFINE_FUNCTION("CNifStringData::CNifStringData()");

 }
/*===========================================================================
 *		End of Class CNifStringData Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifStringData Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifStringData::Destroy (void) {
  //DEFINE_FUNCTION("CNifStringData::Destroy()");
  m_Data.Empty();

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifStringData::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifStringData Method - bool Read (FileHandle);
 *
 * Protected class method to input the record from the current position in
 * the file.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifStringData::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifStringData::Read()");
  bool Result;

  Destroy();

  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = NifReadString(FileHandle, m_Data);
  if (!Result) return (false);

  SetIsLoaded(true);
  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifStringData::Read()
 =========================================================================*/


/*===========================================================================
 *
 * Class CNifStringData Method - bool Write (FileHandle);
 *
 * Protected class method to output the record from the current position in
 * the file.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifStringData::Write (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifStringData::Write()");
  bool Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = NifWriteString(FileHandle, m_Data);
  if (!Result) return (false);
  
  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifStringData::Write()
 =========================================================================*/

