/*===========================================================================
 *
 * File:	Niftextkeyextradata.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFTEXTKEYEXTRADATA_H
#define __NIFTEXTKEYEXTRADATA_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifTextKeyData Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifTextKeyData {

  /*---------- Begin Private Class Members ----------------------*/
private:
  CString	m_Text;
  long		m_Data;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifTextKeyData() {  m_Text = ""; m_Data = 0; }
  virtual ~CNifTextKeyData() { Destroy(); }
  virtual void Destroy (void) { m_Text = ""; m_Data = 0; }

	/* Input output methods */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifTextKeyData Definition
 *=========================================================================*/



/*===========================================================================
 *
 * Begin Class CNifTextKeyExtraData Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifTextKeyExtraData : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long			m_Unknown1;
  long			m_Unknown2;
  long			m_TextCount;
  long			m_Unknown3;
  CNifTextKeyData*	m_pKeyData;
  short			m_Unknown4;
  nifpos_t		m_Position;
  long			m_Unknown5;
  long			m_Unknown6;
  

  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifTextKeyExtraData();
  virtual ~CNifTextKeyExtraData() { Destroy(); }
  virtual void Destroy (void);

	/* Input output methods */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifTextKeyExtraData Definition
 *=========================================================================*/



#endif
/*===========================================================================
 *		End of File Niftextkeyextradata.H
 *=========================================================================*/
