/*===========================================================================
 *
 * File:	NifTextureEffect.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifTextureEffect.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifTextureEffect.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifTextureEffect Constructor
 *
 *=========================================================================*/
CNifTextureEffect::CNifTextureEffect () {
  //DEFINE_FUNCTION("CNifTextureEffect::CNifTextureEffect()");
 }
/*===========================================================================
 *		End of Class CNifTextureEffect Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifTextureEffect Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifTextureEffect::Destroy (void) {
  DEFINE_FUNCTION("CNifTextureEffect::Destroy()");

	/* Call the base class method */
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifTextureEffect::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifTextureEffect Method - bool Read (FileHandle);
 *
 * Input the node data from the current position in the given file.  Assumes
 * that the current position in the file is the byte after the last character
 * in the "NifNode" name record header.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifTextureEffect::Read (CGenFile& FileHandle) {
  bool Result;

	/* Delete the current record contents */
  Destroy();

  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  if (Result) Result = FileHandle.ReadShort(m_Unknown4);
  if (Result) Result = FileHandle.Read((char *)&m_Floats1[0], sizeof(float)*NIF_TEXEFF_NUMFLOATS1);
  if (Result) Result = m_LongArray1.Read(FileHandle);
  if (Result) Result = FileHandle.Read((char *)&m_Floats2[0], sizeof(float)*NIF_TEXEFF_NUMFLOATS2);
  if (Result) Result = FileHandle.ReadLong(m_Unknown7);
  if (Result) Result = FileHandle.ReadLong(m_Unknown8);
  if (Result) Result = FileHandle.ReadLong(m_Unknown9);
  if (Result) Result = FileHandle.ReadLong(m_Unknown10);
  if (Result) Result = FileHandle.ReadLong(m_Unknown11);
  if (Result) Result = FileHandle.ReadChar(m_Unknown12);
  if (Result) Result = FileHandle.Read((char *)&m_Floats3[0], sizeof(float)*NIF_TEXEFF_NUMFLOATS3);
  if (Result) Result = FileHandle.ReadLong(m_Unknown13);
  if (Result) Result = FileHandle.ReadShort(m_Unknown14);
  if (!Result) return (false);
  
	/* Return success */
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifTextureEffect::Read()
 *=========================================================================*/
  

/*===========================================================================
 *
 * Class CNifTextureEffect Method - bool Write (FileHandle);
 *
 * Input the node data to the current position in the given file.  Outputs the
 * record header and data.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifTextureEffect::Write (CGenFile& FileHandle) {
  bool Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  if (Result) Result = FileHandle.WriteShort(m_Unknown4);
  if (Result) Result = FileHandle.Write((char *)&m_Floats1[0], sizeof(float)*NIF_TEXEFF_NUMFLOATS1);
  if (Result) Result = m_LongArray1.Write(FileHandle);
  if (Result) Result = FileHandle.Write((char *)&m_Floats2[0], sizeof(float)*NIF_TEXEFF_NUMFLOATS2);
  if (Result) Result = FileHandle.WriteLong(m_Unknown7);
  if (Result) Result = FileHandle.WriteLong(m_Unknown8);
  if (Result) Result = FileHandle.WriteLong(m_Unknown9);
  if (Result) Result = FileHandle.WriteLong(m_Unknown10);
  if (Result) Result = FileHandle.WriteLong(m_Unknown11);
  if (Result) Result = FileHandle.WriteChar(m_Unknown12);
  if (Result) Result = FileHandle.Write((char *)&m_Floats3[0], sizeof(float)*NIF_TEXEFF_NUMFLOATS3);
  if (Result) Result = FileHandle.WriteLong(m_Unknown13);
  if (Result) Result = FileHandle.WriteShort(m_Unknown14);
  if (!Result) return (false);
  
	/* Return success */
  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifTextureEffect::Write()
 *=========================================================================*/

