/*===========================================================================
 *
 * File:	NifTextureEffect.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFTEXTUREEFFECT_H
#define __NIFTEXTUREEFFECT_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
  #include "NifLongArray.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_TEXEFF_NUMFLOATS1 18
  #define NIF_TEXEFF_NUMFLOATS2 12
  #define NIF_TEXEFF_NUMFLOATS3 4
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifTextureEffect Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifTextureEffect : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long		m_Unknown1;
  long		m_Unknown2;
  long		m_Unknown3;
  short		m_Unknown4;
  float		m_Floats1[NIF_TEXEFF_NUMFLOATS1];
  CNifLongArray m_LongArray1;
  float		m_Floats2[NIF_TEXEFF_NUMFLOATS2];
  long		m_Unknown7;
  long		m_Unknown8;
  long		m_Unknown9;
  long		m_Unknown10;
  long		m_Unknown11;
  char		m_Unknown12;
  float		m_Floats3[NIF_TEXEFF_NUMFLOATS3];
  long		m_Unknown13;
  short		m_Unknown14;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifTextureEffect();
  virtual ~CNifTextureEffect() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifTextureEffect Definition
 *=========================================================================*/



#endif
/*===========================================================================
 *		End of File NifTextureEffect.H
 *=========================================================================*/
