/*===========================================================================
 *
 * File:	NifUVController.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFUVCONTROLLER_H
#define __NIFUVCONTROLLER_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_VISCON_NUMFLOATS 4
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifUVController Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifUVController : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long		m_Unknown1;
  short		m_Unknown2;
  float		m_Floats[NIF_VISCON_NUMFLOATS];
  long		m_Unknown3;
  long		m_Unknown4;
  short		m_Unknown5;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifUVController();
  virtual ~CNifUVController() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifUVController Definition
 *=========================================================================*/



#endif
/*===========================================================================
 *		End of File Nifviscontroller.H
 *=========================================================================*/
