/*===========================================================================
 *
 * File:	NifVertWeightsExtraData.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifVertWeightsExtraData.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifVertWeightsExtraData.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifVertWeightsExtraData Constructor
 *
 *=========================================================================*/
CNifVertWeightsExtraData::CNifVertWeightsExtraData () {
  //DEFINE_FUNCTION("CNifVertWeightsExtraData::CNifVertWeightsExtraData()");
  m_Array.SetOptions(NIFFLOAT_OPTION_SHORTSIZE);
 }
/*===========================================================================
 *		End of Class CNifVertWeightsExtraData Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifVertWeightsExtraData Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifVertWeightsExtraData::Destroy (void) {
  //DEFINE_FUNCTION("CNifVertWeightsExtraData::Destroy()");
  m_Array.Destroy();

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifVertWeightsExtraData::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifVertWeightsExtraData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifVertWeightsExtraData::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifVertWeightsExtraData::Read()");
  bool Result;

  Destroy();

  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = m_Array.Read(FileHandle);
  if (!Result) return (false);

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifVertWeightsExtraData::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifVertWeightsExtraData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifVertWeightsExtraData::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifVertWeightsExtraData::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = m_Array.Write(FileHandle);
  if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifVertWeightsExtraData::Write()
 *=========================================================================*/