/*===========================================================================
 *
 * File:	Mwesm_String.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Wednesday, September 04, 2002
 *
 * Defines the CMwEsmString class.
 *
 *=========================================================================*/
#ifndef __MWESM_STRING_H
#define __MWESM_STRING_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "mwesm_baserec.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CMwEsmString Definition
 *
 * Holds a single string within an ESM record.
 *
 *=========================================================================*/
class CMwEsmString {

  /*---------- Begin Private Class Members ----------------------*/
private:
  char		m_Name[MWESM_HEADERNAME_SIZE];
  long		m_StringSize;
  char*		m_pString;
  bool		m_IsLoaded;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CMwEsmString();
  virtual ~CMwEsmString() { Destroy(); }
  virtual void Destroy (void);

	/* Get class members */
  const char*	GetString	(void) const { return (m_pString); }
  const char*	GetName		(void) const { return (m_Name); }
  long		GetStringSize	(void) const { return (m_StringSize); }
  bool		IsLoaded	(void) const { return (m_IsLoaded); }

	/* Input and output methods */
  virtual bool Read	  (CGenFile& File);
  virtual bool ReadString (CGenFile& File, const char* pName, const long StringSize);
  virtual bool Write	  (CGenFile& File);


 };
/*===========================================================================
 *		End of Class CMwEsmString Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Mwesm_tes3.H
 *=========================================================================*/


