/*===========================================================================
 *
 * File:	Mwesm_util.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Saturday, September 07, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "mwesm_util.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("MWESM_Util.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Function - int l_AddRecordTree (pRecord, pUserData);
 *
 * Local function used to add records to a tree control.
 *
 *=========================================================================*/
int l_AddRecordTree (CMwEsmBaseRecord* pRecord, void* pUserData) {
  DEFINE_FUNCTION("l_AddRecordTree()");
  char Buffer[64];

  CTreeCtrl* pTree = (CTreeCtrl *) pUserData;

  ASSERT(pTree != NULL && pRecord != NULL);

  sprintf (Buffer, "%4.4s (%ld bytes)", pRecord->GetName(), pRecord->GetSize());
  pTree->InsertItem(Buffer);
  return (0);
 }
/*===========================================================================
 *		End of Function l_AddRecordTree()
 *=========================================================================*/



/*===========================================================================
 *
 * Function - bool MwEsmCreateTree (EsmFile, TreeCtrl);
 *
 * Fills the given tree control with the contents of the ESM file.  Returns
 * false on any error.
 *
 *=========================================================================*/
bool MwEsmCreateTree (CMwEsmFile& EsmFile, CTreeCtrl& TreeCtrl) {
  int Result;

  TreeCtrl.ShowWindow(SW_HIDE);
  TreeCtrl.DeleteAllItems();
  Result = EsmFile.ForEachRecord(l_AddRecordTree, &TreeCtrl);
  TreeCtrl.ShowWindow(SW_SHOW);

  return (Result >= 0);
 }
/*===========================================================================
 *		End of Function MwEsmCreateTree()
 *=========================================================================*/